DEFINT A-Z
DECLARE FUNCTION Month2Str$ (Month%)
DECLARE SUB DateExtract (dat$, Month%, day%, Year%)
DECLARE FUNCTION DayOfTheWeek$ (dat$)
DECLARE FUNCTION DateToJulian! (dat$)
DECLARE FUNCTION DateValid% (dat$)
CLS

day$ = DayOfTheWeek(DATE$)
Month$ = Month2Str$(VAL(LEFT$(DATE$, 2)))
daynum$ = MID$(DATE$, 4, 2)

PRINT day$ + " "; Month$ + " " + daynum$; ", " + RIGHT$(DATE$, 4)

DEFSNG A-Z
SUB DateExtract (dat$, Month%, day%, Year%)
dash = 1
DO
  dash = dash + 1
  a$ = MID$(dat$, dash, 1)
LOOP UNTIL a$ = "-"
Month% = VAL(LEFT$(dat$, dash - 1))
dash2 = dash + 1

DO
  dash2 = dash2 + 1
  a$ = MID$(dat$, dash2, 1)
LOOP UNTIL a$ = "-"
day% = VAL(MID$(dat$, dash + 1, dash2 - dash))

Year% = VAL(MID$(dat$, dash2 + 1, 4))

END SUB

FUNCTION DateToJulian (dat$)

'*******************************************************************************
'*  converts gregorian-style mm/dd/yyyy date to julian date                    *
'*******************************************************************************

    DateExtract dat$, Month%, day%, Year%

    SELECT CASE Month%
       CASE IS > 2
          Month% = Month% - 3
       CASE IS <= 2
          Month% = Month% + 9
          Year% = Year% - 1
    END SELECT

    a = 146097# * FIX(FIX(Year% / 100) / 4)
    B = FIX(1461# * (Year% MOD 100) / 4)
    C = FIX((153# * Month% + 2) / 5) + day% + 1721119

    DateToJulian = a + B + C

    END FUNCTION

FUNCTION DateValid% (dat$)

dat$ = LTRIM$(RTRIM$(dat$))

DateExtract dat$, Month%, day%, Year%


'*******************************************************************************
'*  returns 1 if date given is a legal date                                    *
'*******************************************************************************

    SELECT CASE Month%                   'verify date within month
     
       CASE 4, 6, 9, 11                  'months that should
          SELECT CASE day%               'only  have
             CASE 1 TO 30                '30 days
             CASE ELSE                   'otherwise
                DateValid% = 0           'not valid
                EXIT FUNCTION
          END SELECT

       CASE 1, 3, 5, 7, 8, 10, 12        'months that
          SELECT CASE day%               'should have
             CASE 1 TO 31                '31 days
             CASE ELSE                   'otherwise
                DateValid% = 0           'not valid
                EXIT FUNCTION
          END SELECT
                
       CASE 2                            'February
          SELECT CASE Year% MOD 4        'account for leap years
             CASE 0                      'a leap year
                SELECT CASE day%
                   CASE 1 TO 29          'may have 29 days
                    CASE ELSE                        '
                       DateValid% = 0    'not valid
                       EXIT FUNCTION
                END SELECT
             CASE ELSE                   'not a leap year
                SELECT CASE day%
                   CASE 1 TO 28          'only 28 days acceptable
                   CASE ELSE
                      DateValid% = 0
                      EXIT FUNCTION
                END SELECT
          END SELECT
                                       
       CASE ELSE                         'anything else
          DateValid% = 0                 'is invalid date entry
          EXIT FUNCTION
  
    END SELECT
  
    DateValid% = 1                       'Date passes all tests

    END FUNCTION

FUNCTION DayOfTheWeek$ (dat$)

'*******************************************************************************
'*  returns day of week given date in form mm/dd/yyyy                          *
'*******************************************************************************

    JulianDate = DateToJulian(dat$)

    SELECT CASE JulianDate - (FIX(JulianDate / 7) * 7) + 1

       CASE 0, 7
          DayOfTheWeek$ = "Monday"
       CASE 1
          DayOfTheWeek$ = "Tuesday"
       CASE 2
          DayOfTheWeek$ = "Wednesday"
       CASE 3
          DayOfTheWeek$ = "Thursday"
       CASE 4
          DayOfTheWeek$ = "Friday"
       CASE 5
          DayOfTheWeek$ = "Saturday"
       CASE 6
          DayOfTheWeek$ = "Sunday"

    END SELECT

END FUNCTION

DEFINT A-Z
FUNCTION Month2Str$ (Month%)
SELECT CASE Month
  CASE 1
    Month2Str = "January"
  CASE 2
    Month2Str = "February"
  CASE 3
    Month2Str = "March"
  CASE 4
    Month2Str = "April"
  CASE 5
    Month2Str = "May"
  CASE 6
    Month2Str = "June"
  CASE 7
    Month2Str = "July"
  CASE 8
    Month2Str = "August"
  CASE 9
    Month2Str = "September"
  CASE 10
    Month2Str = "October"
  CASE 11
    Month2Str = "November"
  CASE 12
    Month2Str = "December"
END SELECT
END FUNCTION

